Tool: cancel_job
Cancel a running BigQuery job.
Use this tool to cancel a query job that is currently executing (i.e. returned job_complete: false with a job_id from execute_sql or execute_sql_readonly). Specify the job_id to abort.
The following code sample shows how to use curl to call the cancel_job MCP tool.
| Curl Request |
|---|
curl --location 'https://bigquery.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "cancel_job", "arguments": { // Provide these details according to the MCP tool specification. } }, "jsonrpc": "2.0", "id": 1 }' |
Input Schema
Request for cancelling a job.
CancelJobRequest
| JSON representation |
|---|
{ "projectId": string, "jobId": string, "location": string } |
| Fields | |
|---|---|
projectId |
Required. Project ID of the job to cancel. |
jobId |
Required. Job ID of the job to cancel. |
location |
Optional. The geographic location of the job. |
Output Schema
Describes format of a jobs cancellation response.
JobCancelResponse
| JSON representation |
|---|
{
"kind": string,
"job": {
object ( |
| Fields | |
|---|---|
kind |
The resource type of the response. |
job |
The final state of the job. |
Job
| JSON representation |
|---|
{ "kind": string, "etag": string, "id": string, "selfLink": string, "user_email": string, "configuration": { object ( |
| Fields | |
|---|---|
kind |
Output only. The type of the resource. |
etag |
Output only. A hash of this resource. |
id |
Output only. Opaque ID field of the job. |
selfLink |
Output only. A URL that can be used to access the resource again. |
user_email |
Output only. Email address of the user who ran the job. |
configuration |
Required. Describes the job configuration. |
jobReference |
Optional. Reference describing the unique-per-user name of the job. |
statistics |
Output only. Information about the job, including starting time and ending time of the job. |
status |
Output only. The status of this job. Examine this value when polling an asynchronous job to see if the job is complete. |
principal_subject |
Output only. [Full-projection-only] String representation of identity of requesting party. Populated for both first- and third-party identities. Only present for APIs that support third-party identities. |
jobCreationReason |
Output only. The reason why a Job was created. |
JobConfiguration
| JSON representation |
|---|
{ "jobType": string, "query": { object ( |
| Fields | |
|---|---|
jobType |
Output only. The type of the job. Can be QUERY, LOAD, EXTRACT, COPY or UNKNOWN. |
query |
[Pick one] Configures a query job. |
load |
[Pick one] Configures a load job. |
copy |
[Pick one] Copies a table. |
extract |
[Pick one] Configures an extract job. |
dryRun |
Optional. If set, don't actually run this job. A valid query will return a mostly empty response with some processing statistics, while an invalid query will return the same error it would if it wasn't a dry run. Behavior of non-query jobs is undefined. |
jobTimeoutMs |
Optional. Job timeout in milliseconds relative to the job creation time. If this time limit is exceeded, BigQuery attempts to stop the job, but might not always succeed in canceling it before the job completes. For example, a job that takes more than 60 seconds to complete has a better chance of being stopped than a job that takes 10 seconds to complete. |
labels |
The labels associated with this job. You can use these to organize and group your jobs. Label keys and values can be no longer than 63 characters, can only contain lowercase letters, numeric characters, underscores and dashes. International characters are allowed. Label values are optional. Label keys must start with a letter and each label in the list must have a different key. An object containing a list of |
Union field
|
|
maxSlots |
Optional. A target limit on the rate of slot consumption by this job. If set to a value > 0, BigQuery will attempt to limit the rate of slot consumption by this job to keep it below the configured limit, even if the job is eligible for more slots based on fair scheduling. The unused slots will be available for other jobs and queries to use. Note: This feature is not yet generally available. |
Union field
|
|
reservation |
Optional. The reservation that job would use. User can specify a reservation to execute the job. If reservation is not set, reservation is determined based on the rules defined by the reservation assignments. The expected format is |
JobConfigurationQuery
| JSON representation |
|---|
{ "query": string, "destinationTable": { object ( |
| Fields | |
|---|---|
query |
[Required] SQL query text to execute. The useLegacySql field can be used to indicate whether the query uses legacy SQL or GoogleSQL. |
destinationTable |
Optional. Describes the table where the query results should be stored. This property must be set for large results that exceed the maximum response size. For queries that produce anonymous (cached) results, this field will be populated by BigQuery. |
tableDefinitions |
Optional. You can specify external table definitions, which operate as ephemeral tables that can be queried. These definitions are configured using a JSON map, where the string key represents the table identifier, and the value is the corresponding external data configuration object. An object containing a list of |
userDefinedFunctionResources[] |
Describes user-defined function resources used in the query. |
createDisposition |
Optional. Specifies whether the job is allowed to create new tables. The following values are supported:
The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion. |
writeDisposition |
Optional. Specifies the action that occurs if the destination table already exists. The following values are supported:
The default value is WRITE_EMPTY. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion. |
defaultDataset |
Optional. Specifies the default dataset to use for unqualified table names in the query. This setting does not alter behavior of unqualified dataset names. Setting the system variable |
priority |
Optional. Specifies a priority for the query. Possible values include INTERACTIVE and BATCH. The default value is INTERACTIVE. |
preserveNulls |
[Deprecated] This property is deprecated. |
allowLargeResults |
Optional. If true and query uses legacy SQL dialect, allows the query to produce arbitrarily large result tables at a slight cost in performance. Requires destinationTable to be set. For GoogleSQL queries, this flag is ignored and large results are always allowed. However, you must still set destinationTable when result size exceeds the allowed maximum response size. |
useQueryCache |
Optional. Whether to look for the result in the query cache. The query cache is a best-effort cache that will be flushed whenever tables in the query are modified. Moreover, the query cache is only available when a query does not have a destination table specified. The default value is true. |
flattenResults |
Optional. If true and query uses legacy SQL dialect, flattens all nested and repeated fields in the query results. allowLargeResults must be true if this is set to false. For GoogleSQL queries, this flag is ignored and results are never flattened. |
maximumBillingTier |
Optional. [Deprecated] Maximum billing tier allowed for this query. The billing tier controls the amount of compute resources allotted to the query, and multiplies the on-demand cost of the query accordingly. A query that runs within its allotted resources will succeed and indicate its billing tier in statistics.query.billingTier, but if the query exceeds its allotted resources, it will fail with billingTierLimitExceeded. WARNING: The billed byte amount can be multiplied by an amount up to this number! Most users should not need to alter this setting, and we recommend that you avoid introducing new uses of it. |
maximumBytesBilled |
Limits the bytes billed for this job. Queries that will have bytes billed beyond this limit will fail (without incurring a charge). If unspecified, this will be set to your project default. |
useLegacySql |
Optional. Specifies whether to use BigQuery's legacy SQL dialect for this query. The default value is true. If set to false, the query uses BigQuery's GoogleSQL. When useLegacySql is set to false, the value of flattenResults is ignored; query will be run as if flattenResults is false. |
parameterMode |
GoogleSQL only. Set to POSITIONAL to use positional (?) query parameters or to NAMED to use named (@myparam) query parameters in this query. |
queryParameters[] |
Query parameters for GoogleSQL queries. |
schemaUpdateOptions[] |
Allows the schema of the destination table to be updated as a side effect of the query job. Schema update options are supported in three cases: when writeDisposition is WRITE_APPEND; when writeDisposition is WRITE_TRUNCATE_DATA; when writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table, specified by partition decorators. For normal tables, WRITE_TRUNCATE will always overwrite the schema. One or more of the following values are specified:
|
timePartitioning |
Time-based partitioning specification for the destination table. Only one of timePartitioning and rangePartitioning should be specified. |
rangePartitioning |
Range partitioning specification for the destination table. Only one of timePartitioning and rangePartitioning should be specified. |
clustering |
Clustering specification for the destination table. |
destinationEncryptionConfiguration |
Custom encryption configuration (e.g., Cloud KMS keys) |
scriptOptions |
Options controlling the execution of scripts. |
connectionProperties[] |
Connection properties which can modify the query behavior. |
createSession |
If this property is true, the job creates a new session using a randomly generated session_id. To continue using a created session with subsequent queries, pass the existing session identifier as a The new session's location will be set to |
continuous |
Optional. Whether to run the query as continuous or a regular query. Continuous query is currently in experimental stage and not ready for general usage. |
writeIncrementalResults |
Optional. This is only supported for a SELECT query using a temporary table. If set, the query is allowed to write results incrementally to the temporary result table. This may incur a performance penalty. This option cannot be used with Legacy SQL. This feature is not yet available. |
secureContext |
Optional. A set of key-value pairs representing the secure context. This can be used to pass sensitive or context-specific information. They can be retrieved via the SECURE_CONTEXT() function and used to modify the run-time behavior of a query. |
Union field
|
|
systemVariables |
Output only. System variables for GoogleSQL queries. A system variable is output if the variable is settable and its value differs from the system default. "@@" prefix is not included in the name of the System variables. |
TableReference
| JSON representation |
|---|
{ "projectId": string, "datasetId": string, "tableId": string } |
| Fields | |
|---|---|
projectId |
Required. The ID of the project containing this table. |
datasetId |
Required. The ID of the dataset containing this table. |
tableId |
Required. The ID of the table. The ID can contain Unicode characters in category L (letter), M (mark), N (number), Pc (connector, including underscore), Pd (dash), and Zs (space). For more information, see General Category. The maximum length is 1,024 characters. Certain operations allow suffixing of the table ID with a partition decorator, such as |
ExternalTableDefinitionsEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
ExternalDataConfiguration
| JSON representation |
|---|
{ "sourceUris": [ string ], "fileSetSpecType": enum ( |
| Fields | |
|---|---|
sourceUris[] |
[Required] The fully-qualified URIs that point to your data in Google Cloud. For Google Cloud Storage URIs: Each URI can contain one '*' wildcard character and it must come after the 'bucket' name. Size limits related to load jobs apply to external data sources. For Google Cloud Bigtable URIs: Exactly one URI can be specified and it has be a fully specified and valid HTTPS URL for a Google Cloud Bigtable table. For Google Cloud Datastore backups, exactly one URI can be specified. Also, the '*' wildcard character is not allowed. |
fileSetSpecType |
Optional. Specifies how source URIs are interpreted for constructing the file set to load. By default source URIs are expanded against the underlying storage. Other options include specifying manifest files. Only applicable to object storage systems. |
schema |
Optional. The schema for the data. Schema is required for CSV and JSON formats if autodetect is not on. Schema is disallowed for Google Cloud Bigtable, Cloud Datastore backups, Avro, ORC and Parquet formats. |
sourceFormat |
[Required] The data format. For CSV files, specify "CSV". For Google sheets, specify "GOOGLE_SHEETS". For newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON". For Avro files, specify "AVRO". For Google Cloud Datastore backups, specify "DATASTORE_BACKUP". For Apache Iceberg tables, specify "ICEBERG". For ORC files, specify "ORC". For Parquet files, specify "PARQUET". [Beta] For Google Cloud Bigtable, specify "BIGTABLE". |
maxBadRecords |
Optional. The maximum number of bad records that BigQuery can ignore when reading data. If the number of bad records exceeds this value, an invalid error is returned in the job result. The default value is 0, which requires that all records are valid. This setting is ignored for Google Cloud Bigtable, Google Cloud Datastore backups, Avro, ORC and Parquet formats. |
autodetect |
Try to detect schema and format options automatically. Any option specified explicitly will be honored. |
ignoreUnknownValues |
Optional. Indicates if BigQuery should allow extra values that are not represented in the table schema. If true, the extra values are ignored. If false, records with extra columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. The sourceFormat property determines what BigQuery treats as an extra value: CSV: Trailing columns JSON: Named values that don't match any column names Google Cloud Bigtable: This setting is ignored. Google Cloud Datastore backups: This setting is ignored. Avro: This setting is ignored. ORC: This setting is ignored. Parquet: This setting is ignored. |
compression |
Optional. The compression type of the data source. Possible values include GZIP and NONE. The default value is NONE. This setting is ignored for Google Cloud Bigtable, Google Cloud Datastore backups, Avro, ORC and Parquet formats. An empty string is an invalid value. |
csvOptions |
Optional. Additional properties to set if sourceFormat is set to CSV. |
jsonOptions |
Optional. Additional properties to set if sourceFormat is set to JSON. |
bigtableOptions |
Optional. Additional options if sourceFormat is set to BIGTABLE. |
googleSheetsOptions |
Optional. Additional options if sourceFormat is set to GOOGLE_SHEETS. |
hivePartitioningOptions |
Optional. When set, configures hive partitioning support. Not all storage formats support hive partitioning -- requesting hive partitioning on an unsupported format will lead to an error, as will providing an invalid specification. |
connectionId |
Optional. The connection specifying the credentials to be used to read external storage, such as Azure Blob, Cloud Storage, or S3. The connection_id can have the form |
decimalTargetTypes[] |
Defines the list of possible SQL data types to which the source decimal values are converted. This list and the precision and the scale parameters of the decimal field determine the target type. In the order of NUMERIC, BIGNUMERIC, and STRING, a type is picked if it is in the specified list and if it supports the precision and the scale. STRING supports all precision and scale values. If none of the listed types supports the precision and the scale, the type supporting the widest range in the specified list is picked, and if a value exceeds the supported range when reading the data, an error will be thrown. Example: Suppose the value of this field is ["NUMERIC", "BIGNUMERIC"]. If (precision,scale) is:
This field cannot contain duplicate types. The order of the types in this field is ignored. For example, ["BIGNUMERIC", "NUMERIC"] is the same as ["NUMERIC", "BIGNUMERIC"] and NUMERIC always takes precedence over BIGNUMERIC. Defaults to ["NUMERIC", "STRING"] for ORC and ["NUMERIC"] for the other file formats. |
avroOptions |
Optional. Additional properties to set if sourceFormat is set to AVRO. |
jsonExtension |
Optional. Load option to be used together with source_format newline-delimited JSON to indicate that a variant of JSON is being loaded. To load newline-delimited GeoJSON, specify GEOJSON (and source_format must be set to NEWLINE_DELIMITED_JSON). |
parquetOptions |
Optional. Additional properties to set if sourceFormat is set to PARQUET. |
referenceFileSchemaUri |
Optional. When creating an external table, the user can provide a reference file with the table schema. This is enabled for the following formats: AVRO, PARQUET, ORC. |
metadataCacheMode |
Optional. Metadata Cache Mode for the table. Set this to enable caching of metadata from external data source. |
timestampTargetPrecision[] |
Precisions (maximum number of total digits in base 10) for seconds of TIMESTAMP types that are allowed to the destination table for autodetection mode. Available for the formats: CSV, PARQUET, AVRO, and Iceberg External Table. Possible values include: Not Specified, [], or [6]: timestamp(6) for all auto detected TIMESTAMP columns [6, 12]: timestamp(6) for all auto detected TIMESTAMP columns that have less than 6 digits of subseconds. timestamp(12) for all auto detected TIMESTAMP columns that have more than 6 digits of subseconds. [12]: timestamp(12) for all auto detected TIMESTAMP columns. The order of the elements in this array is ignored. Inputs that have higher precision than the highest target precision in this array will be truncated. |
Union field
|
|
objectMetadata |
Optional. ObjectMetadata is used to create Object Tables. Object Tables contain a listing of objects (with their metadata) found at the source_uris. If ObjectMetadata is set, source_format should be omitted. Currently SIMPLE is the only supported Object Metadata type. |
Union field
|
|
timeZone |
Optional. Time zone used when parsing timestamp values that do not have specific time zone information (e.g. 2024-04-20 12:34:56). The expected format is a IANA timezone string (e.g. America/Los_Angeles). |
Union field
|
|
dateFormat |
Optional. Format used to parse DATE values. Supports C-style and SQL-style values. |
Union field
|
|
datetimeFormat |
Optional. Format used to parse DATETIME values. Supports C-style and SQL-style values. |
Union field
|
|
timeFormat |
Optional. Format used to parse TIME values. Supports C-style and SQL-style values. |
Union field
|
|
timestampFormat |
Optional. Format used to parse TIMESTAMP values. Supports C-style and SQL-style values. |
TableSchema
| JSON representation |
|---|
{ "fields": [ { object ( |
| Fields | |
|---|---|
fields[] |
Describes the fields in a table. |
foreignTypeInfo |
Optional. Specifies metadata of the foreign data type definition in field schema ( |
TableFieldSchema
| JSON representation |
|---|
{ "name": string, "type": string, "mode": string, "fields": [ { object ( |
| Fields | |
|---|---|
name |
Required. The field name. The name must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_), and must start with a letter or underscore. The maximum length is 300 characters. |
type |
Required. The field data type. Possible values include:
Use of RECORD/STRUCT indicates that the field contains a nested schema. |
mode |
Optional. The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default value is NULLABLE. |
fields[] |
Optional. Describes the nested schema fields if the type property is set to RECORD. |
description |
Optional. The field description. The maximum length is 1,024 characters. |
policyTags |
Optional. The policy tags attached to this field, used for field-level access control. If not set, defaults to empty policy_tags. |
dataGovernanceTagsInfo |
Optional. Specifies the data governance tags on this field. This field works with other column-level security fields as follows:
|
dataPolicies[] |
Optional. Data policies attached to this field, used for field-level access control. |
dataPolicyList |
Optional. Specifies data policies attached to this field, used for field-level access control. When set, this will be the source of truth for data policy information. |
maxLength |
Optional. Maximum length of values of this field for STRINGS or BYTES. If max_length is not specified, no maximum length constraint is imposed on this field. If type = "STRING", then max_length represents the maximum UTF-8 length of strings in this field. If type = "BYTES", then max_length represents the maximum number of bytes in this field. It is invalid to set this field if type ≠ "STRING" and ≠ "BYTES". |
precision |
Optional. Precision (maximum number of total digits in base 10) and scale (maximum number of digits in the fractional part in base 10) constraints for values of this field for NUMERIC or BIGNUMERIC. It is invalid to set precision or scale if type ≠ "NUMERIC" and ≠ "BIGNUMERIC". If precision and scale are not specified, no value range constraint is imposed on this field insofar as values are permitted by the type. Values of this NUMERIC or BIGNUMERIC field must be in this range when:
Acceptable values for precision and scale if both are specified:
Acceptable values for precision if only precision is specified but not scale (and thus scale is interpreted to be equal to zero):
If scale is specified but not precision, then it is invalid. |
scale |
Optional. See documentation for precision. |
timestampPrecision |
Optional. Precision (maximum number of total digits in base 10) for seconds of TIMESTAMP type. Possible values include: * 6 (Default, for TIMESTAMP type with microsecond precision) * 12 (For TIMESTAMP type with picosecond precision) |
roundingMode |
Optional. Specifies the rounding mode to be used when storing values of NUMERIC and BIGNUMERIC type. |
collation |
Optional. Field collation can be set only when the type of field is STRING. The following values are supported:
|
defaultValueExpression |
Optional. A SQL expression to specify the default value for this field. |
rangeElementType |
Optional. The subtype of the RANGE, if the type of this field is RANGE. If the type is RANGE, this field is required. Values for the field element type can be the following:
|
foreignTypeDefinition |
Optional. Definition of the foreign data type. Only valid for top-level schema fields (not nested fields). If the type is FOREIGN, this field is required. |
generatedColumn |
Optional. Definition of how values are generated for the field. Only valid for top-level schema fields (not nested fields). |
StringValue
| JSON representation |
|---|
{ "value": string } |
| Fields | |
|---|---|
value |
The string value. |
PolicyTagList
| JSON representation |
|---|
{ "names": [ string ] } |
| Fields | |
|---|---|
names[] |
A list of policy tag resource names. For example, "projects/1/locations/eu/taxonomies/2/policyTags/3". At most 1 policy tag is currently allowed. |
DataGovernanceTagsInfo
| JSON representation |
|---|
{ "dataGovernanceTags": { string: string, ... } } |
| Fields | |
|---|---|
dataGovernanceTags |
Optional. The data governance tags added to this field are used for field-level access control. Only one data governance tag is currently supported on a field. Tag keys are globally unique. Tag key is expected to be in the namespaced format, for example "parent-id/pii" where parent-id is the ID of the parent organization or project resource for this tag key. Tag value is expected to be the short name, for example "sensitive". See Tag definitions for more details. For example: "parent-id/pii": "sensitive", "myProject/cost_center": "sales" An object containing a list of |
DataGovernanceTagsEntry
| JSON representation |
|---|
{ "key": string, "value": string } |
| Fields | |
|---|---|
key |
|
value |
|
DataPolicyOption
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
name |
Data policy resource name in the form of projects/project_id/locations/location_id/dataPolicies/data_policy_id. |
DataPolicyList
| JSON representation |
|---|
{
"dataPolicies": [
{
object ( |
| Fields | |
|---|---|
dataPolicies[] |
Contains a list of data policy options. At most 9 data policies are allowed per field. |
Int64Value
| JSON representation |
|---|
{ "value": string } |
| Fields | |
|---|---|
value |
The int64 value. |
FieldElementType
| JSON representation |
|---|
{ "type": string } |
| Fields | |
|---|---|
type |
Required. The type of a field element. For more information, see |
GeneratedColumn
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
generatedMode |
Optional. Dictates when system generated values are used to populate the field. |
Union field
|
|
generatedExpressionInfo |
Definition of the expression used to generate the field. |
GeneratedExpressionInfo
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
generationExpression |
Optional. The generation expression (e.g. AI.EMBED(...)) used to generate the field. |
Union field
|
|
asynchronous |
Optional. Whether the column generation is done asynchronously. |
Union field
|
|
stored |
Optional. Whether the generated column is stored in the table. |
ForeignTypeInfo
| JSON representation |
|---|
{
"typeSystem": enum ( |
| Fields | |
|---|---|
typeSystem |
Required. Specifies the system which defines the foreign data type. |
Int32Value
| JSON representation |
|---|
{ "value": integer } |
| Fields | |
|---|---|
value |
The int32 value. |
BoolValue
| JSON representation |
|---|
{ "value": boolean } |
| Fields | |
|---|---|
value |
The bool value. |
CsvOptions
| JSON representation |
|---|
{ "fieldDelimiter": string, "skipLeadingRows": string, "quote": string, "allowQuotedNewlines": boolean, "allowJaggedRows": boolean, "encoding": string, "preserveAsciiControlCharacters": boolean, "nullMarker": string, "nullMarkers": [ string ], "sourceColumnMatch": string } |
| Fields | |
|---|---|
fieldDelimiter |
Optional. The separator character for fields in a CSV file. The separator is interpreted as a single byte. For files encoded in ISO-8859-1, any single character can be used as a separator. For files encoded in UTF-8, characters represented in decimal range 1-127 (U+0001-U+007F) can be used without any modification. UTF-8 characters encoded with multiple bytes (i.e. U+0080 and above) will have only the first byte used for separating fields. The remaining bytes will be treated as a part of the field. BigQuery also supports the escape sequence "\t" (U+0009) to specify a tab separator. The default value is comma (",", U+002C). |
skipLeadingRows |
Optional. The number of rows at the top of a CSV file that BigQuery will skip when reading the data. The default value is 0. This property is useful if you have header rows in the file that should be skipped. When autodetect is on, the behavior is the following:
|
quote |
Optional. The value that is used to quote data sections in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. The default value is a double-quote ("). If your data does not contain quoted sections, set the property value to an empty string. If your data contains quoted newline characters, you must also set the allowQuotedNewlines property to true. To include the specific quote character within a quoted value, precede it with an additional matching quote character. For example, if you want to escape the default character ' " ', use ' "" '. |
allowQuotedNewlines |
Optional. Indicates if BigQuery should allow quoted data sections that contain newline characters in a CSV file. The default value is false. |
allowJaggedRows |
Optional. Indicates if BigQuery should accept rows that are missing trailing optional columns. If true, BigQuery treats missing trailing columns as null values. If false, records with missing trailing columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. |
encoding |
Optional. The character encoding of the data. The supported values are UTF-8, ISO-8859-1, UTF-16BE, UTF-16LE, UTF-32BE, and UTF-32LE. The default value is UTF-8. BigQuery decodes the data after the raw, binary data has been split using the values of the quote and fieldDelimiter properties. |
preserveAsciiControlCharacters |
Optional. Indicates if the embedded ASCII control characters (the first 32 characters in the ASCII-table, from '\x00' to '\x1F') are preserved. |
nullMarker |
Optional. Specifies a string that represents a null value in a CSV file. For example, if you specify "\N", BigQuery interprets "\N" as a null value when querying a CSV file. The default value is the empty string. If you set this property to a custom value, BigQuery throws an error if an empty string is present for all data types except for STRING and BYTE. For STRING and BYTE columns, BigQuery interprets the empty string as an empty value. |
nullMarkers[] |
Optional. A list of strings represented as SQL NULL value in a CSV file. null_marker and null_markers can't be set at the same time. If null_marker is set, null_markers has to be not set. If null_markers is set, null_marker has to be not set. If both null_marker and null_markers are set at the same time, a user error would be thrown. Any strings listed in null_markers, including empty string would be interpreted as SQL NULL. This applies to all column types. |
sourceColumnMatch |
Optional. Controls the strategy used to match loaded columns to the schema. If not set, a sensible default is chosen based on how the schema is provided. If autodetect is used, then columns are matched by name. Otherwise, columns are matched by position. This is done to keep the behavior backward-compatible. Acceptable values are: POSITION - matches by position. This assumes that the columns are ordered the same way as the schema. NAME - matches by name. This reads the header row as column names and reorders columns to match the field names in the schema. |
JsonOptions
| JSON representation |
|---|
{ "encoding": string } |
| Fields | |
|---|---|
encoding |
Optional. The character encoding of the data. The supported values are UTF-8, UTF-16BE, UTF-16LE, UTF-32BE, and UTF-32LE. The default value is UTF-8. |
BigtableOptions
| JSON representation |
|---|
{
"columnFamilies": [
{
object ( |
| Fields | |
|---|---|
columnFamilies[] |
Optional. List of column families to expose in the table schema along with their types. This list restricts the column families that can be referenced in queries and specifies their value types. You can use this list to do type conversions - see the 'type' field for more details. If you leave this list empty, all column families are present in the table schema and their values are read as BYTES. During a query only the column families referenced in that query are read from Bigtable. |
ignoreUnspecifiedColumnFamilies |
Optional. If field is true, then the column families that are not specified in columnFamilies list are not exposed in the table schema. Otherwise, they are read with BYTES type values. The default value is false. |
readRowkeyAsString |
Optional. If field is true, then the rowkey column families will be read and converted to string. Otherwise they are read with BYTES type values and users need to manually cast them with CAST if necessary. The default value is false. |
outputColumnFamiliesAsJson |
Optional. If field is true, then each column family will be read as a single JSON column. Otherwise they are read as a repeated cell structure containing timestamp/value tuples. The default value is false. |
BigtableColumnFamily
| JSON representation |
|---|
{ "familyId": string, "type": string, "encoding": string, "columns": [ { object ( |
| Fields | |
|---|---|
familyId |
Identifier of the column family. |
type |
Optional. The type to convert the value in cells of this column family. The values are expected to be encoded using HBase Bytes.toBytes function when using the BINARY encoding value. Following BigQuery types are allowed (case-sensitive):
Default type is BYTES. This can be overridden for a specific column by listing that column in 'columns' and specifying a type for it. |
encoding |
Optional. The encoding of the values when the type is not STRING. Acceptable encoding values are: TEXT - indicates values are alphanumeric text strings. BINARY - indicates values are encoded using HBase Bytes.toBytes family of functions. PROTO_BINARY - indicates values are encoded using serialized proto messages. This can only be used in combination with JSON type. This can be overridden for a specific column by listing that column in 'columns' and specifying an encoding for it. |
columns[] |
Optional. Lists of columns that should be exposed as individual fields as opposed to a list of (column name, value) pairs. All columns whose qualifier matches a qualifier in this list can be accessed as |
onlyReadLatest |
Optional. If this is set only the latest version of value are exposed for all columns in this column family. This can be overridden for a specific column by listing that column in 'columns' and specifying a different setting for that column. |
protoConfig |
Optional. Protobuf-specific configurations, only takes effect when the encoding is PROTO_BINARY. |
BigtableColumn
| JSON representation |
|---|
{
"qualifierEncoded": string,
"qualifierString": string,
"fieldName": string,
"type": string,
"encoding": string,
"onlyReadLatest": boolean,
"protoConfig": {
object ( |
| Fields | |
|---|---|
qualifierEncoded |
[Required] Qualifier of the column. Columns in the parent column family that has this exact qualifier are exposed as |
qualifierString |
Qualifier string. |
fieldName |
Optional. If the qualifier is not a valid BigQuery field identifier i.e. does not match [a-zA-Z][a-zA-Z0-9_]*, a valid identifier must be provided as the column field name and is used as field name in queries. |
type |
Optional. The type to convert the value in cells of this column. The values are expected to be encoded using HBase Bytes.toBytes function when using the BINARY encoding value. Following BigQuery types are allowed (case-sensitive):
Default type is BYTES. 'type' can also be set at the column family level. However, the setting at this level takes precedence if 'type' is set at both levels. |
encoding |
Optional. The encoding of the values when the type is not STRING. Acceptable encoding values are: TEXT - indicates values are alphanumeric text strings. BINARY - indicates values are encoded using HBase Bytes.toBytes family of functions. PROTO_BINARY - indicates values are encoded using serialized proto messages. This can only be used in combination with JSON type. 'encoding' can also be set at the column family level. However, the setting at this level takes precedence if 'encoding' is set at both levels. |
onlyReadLatest |
Optional. If this is set, only the latest version of value in this column are exposed. 'onlyReadLatest' can also be set at the column family level. However, the setting at this level takes precedence if 'onlyReadLatest' is set at both levels. |
protoConfig |
Optional. Protobuf-specific configurations, only takes effect when the encoding is PROTO_BINARY. |
BytesValue
| JSON representation |
|---|
{ "value": string } |
| Fields | |
|---|---|
value |
The bytes value. A base64-encoded string. |
BigtableProtoConfig
| JSON representation |
|---|
{ "schemaBundleId": string, "protoMessageName": string } |
| Fields | |
|---|---|
schemaBundleId |
Optional. The ID of the Bigtable SchemaBundle resource associated with this protobuf. The ID should be referred to within the parent table, e.g., |
protoMessageName |
Optional. The fully qualified proto message name of the protobuf. In the format of "foo.bar.Message". |
GoogleSheetsOptions
| JSON representation |
|---|
{ "skipLeadingRows": string, "range": string } |
| Fields | |
|---|---|
skipLeadingRows |
Optional. The number of rows at the top of a sheet that BigQuery will skip when reading the data. The default value is 0. This property is useful if you have header rows that should be skipped. When autodetect is on, the behavior is the following: * skipLeadingRows unspecified - Autodetect tries to detect headers in the first row. If they are not detected, the row is read as data. Otherwise data is read starting from the second row. * skipLeadingRows is 0 - Instructs autodetect that there are no headers and data should be read starting from the first row. * skipLeadingRows = N > 0 - Autodetect skips N-1 rows and tries to detect headers in row N. If headers are not detected, row N is just skipped. Otherwise row N is used to extract column names for the detected schema. |
range |
Optional. Range of a sheet to query from. Only used when non-empty. Typical format: sheet_name!top_left_cell_id:bottom_right_cell_id For example: sheet1!A1:B20 |
HivePartitioningOptions
| JSON representation |
|---|
{ "mode": string, "sourceUriPrefix": string, "requirePartitionFilter": boolean, "fields": [ string ] } |
| Fields | |
|---|---|
mode |
Optional. When set, what mode of hive partitioning to use when reading data. The following modes are supported:
Not all storage formats support hive partitioning. Requesting hive partitioning on an unsupported format will lead to an error. Currently supported formats are: JSON, CSV, ORC, Avro and Parquet. |
sourceUriPrefix |
Optional. When hive partition detection is requested, a common prefix for all source uris must be required. The prefix must end immediately before the partition key encoding begins. For example, consider files following this data layout: gs://bucket/path_to_table/dt=2019-06-01/country=USA/id=7/file.avro gs://bucket/path_to_table/dt=2019-05-31/country=CA/id=3/file.avro When hive partitioning is requested with either AUTO or STRINGS detection, the common prefix can be either of gs://bucket/path_to_table or gs://bucket/path_to_table/. CUSTOM detection requires encoding the partitioning schema immediately after the common prefix. For CUSTOM, any of
would all be valid source URI prefixes. |
requirePartitionFilter |
Optional. If set to true, queries over this table require a partition filter that can be used for partition elimination to be specified. Note that this field should only be true when creating a permanent external table or querying a temporary external table. Hive-partitioned loads with require_partition_filter explicitly set to true will fail. |
fields[] |
Output only. For permanent external tables, this field is populated with the hive partition keys in the order they were inferred. The types of the partition keys can be deduced by checking the table schema (which will include the partition keys). Not every API will populate this field in the output. For example, Tables.Get will populate it, but Tables.List will not contain this field. |
AvroOptions
| JSON representation |
|---|
{ "useAvroLogicalTypes": boolean } |
| Fields | |
|---|---|
useAvroLogicalTypes |
Optional. If sourceFormat is set to "AVRO", indicates whether to interpret logical types as the corresponding BigQuery data type (for example, TIMESTAMP), instead of using the raw type (for example, INTEGER). |
ParquetOptions
| JSON representation |
|---|
{
"enumAsString": boolean,
"enableListInference": boolean,
"mapTargetType": enum ( |
| Fields | |
|---|---|
enumAsString |
Optional. Indicates whether to infer Parquet ENUM logical type as STRING instead of BYTES by default. |
enableListInference |
Optional. Indicates whether to use schema inference specifically for Parquet LIST logical type. |
mapTargetType |
Optional. Indicates how to represent a Parquet map if present. |
UserDefinedFunctionResource
| JSON representation |
|---|
{ "resourceUri": string, "inlineCode": string } |
| Fields | |
|---|---|
resourceUri |
[Pick one] A code resource to load from a Google Cloud Storage URI (gs://bucket/path). |
inlineCode |
[Pick one] An inline resource that contains code for a user-defined function (UDF). Providing a inline code resource is equivalent to providing a URI for a file containing the same code. |
DatasetReference
| JSON representation |
|---|
{ "datasetId": string, "projectId": string } |
| Fields | |
|---|---|
datasetId |
Required. A unique ID for this dataset, without the project name. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters. |
projectId |
Optional. The ID of the project containing this dataset. |
QueryParameter
| JSON representation |
|---|
{ "name": string, "parameterType": { object ( |
| Fields | |
|---|---|
name |
Optional. If unset, this is a positional parameter. Otherwise, should be unique within a query. |
parameterType |
Required. The type of this parameter. |
parameterValue |
Required. The value of this parameter. |
QueryParameterType
| JSON representation |
|---|
{ "type": string, "arrayType": { object ( |
| Fields | |
|---|---|
type |
Required. The top level type of this field. |
arrayType |
Optional. The type of the array's elements, if this is an array. |
structTypes[] |
Optional. The types of the fields of this struct, in order, if this is a struct. |
rangeElementType |
Optional. The element type of the range, if this is a range. |
Union field
|
|
timestampPrecision |
Optional. Precision (maximum number of total digits in base 10) for seconds of TIMESTAMP type. Possible values include: * 6 (Default, for TIMESTAMP type with microsecond precision) * 12 (For TIMESTAMP type with picosecond precision) |
QueryParameterStructType
| JSON representation |
|---|
{
"name": string,
"type": {
object ( |
| Fields | |
|---|---|
name |
Optional. The name of this field. |
type |
Required. The type of this field. |
description |
Optional. Human-oriented description of the field. |
QueryParameterValue
| JSON representation |
|---|
{ "value": string, "arrayValues": [ { object ( |
| Fields | |
|---|---|
value |
Optional. The value of this value, if a simple scalar type. |
arrayValues[] |
Optional. The array values, if this is an array type. |
structValues |
The struct field values. An object containing a list of |
rangeValue |
Optional. The range value, if this is a range type. |
StructValuesEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
RangeValue
| JSON representation |
|---|
{ "start": { object ( |
| Fields | |
|---|---|
start |
Optional. The start value of the range. A missing value represents an unbounded start. |
end |
Optional. The end value of the range. A missing value represents an unbounded end. |
SystemVariables
| JSON representation |
|---|
{
"types": {
string: {
object ( |
| Fields | |
|---|---|
types |
Output only. Data type for each system variable. An object containing a list of |
values |
Output only. Value for each system variable. |
TypesEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
StandardSqlDataType
| JSON representation |
|---|
{ "typeKind": enum ( |
| Fields | |
|---|---|
typeKind |
Required. The top level type of this field. Can be any GoogleSQL data type (e.g., "INT64", "DATE", "ARRAY"). |
Union field sub_type. For complex types, the sub type information. sub_type can be only one of the following: |
|
arrayElementType |
The type of the array's elements, if type_kind = "ARRAY". |
structType |
The fields of this struct, in order, if type_kind = "STRUCT". |
rangeElementType |
The type of the range's elements, if type_kind = "RANGE". |
StandardSqlStructType
| JSON representation |
|---|
{
"fields": [
{
object ( |
| Fields | |
|---|---|
fields[] |
Fields within the struct. |
StandardSqlField
| JSON representation |
|---|
{
"name": string,
"type": {
object ( |
| Fields | |
|---|---|
name |
Optional. The name of this field. Can be absent for struct fields. |
type |
Optional. The type of this parameter. Absent if not explicitly specified (e.g., CREATE FUNCTION statement can omit the return type; in this case the output parameter does not have this "type" field). |
Struct
| JSON representation |
|---|
{ "fields": { string: value, ... } } |
| Fields | |
|---|---|
fields |
Unordered map of dynamically typed values. An object containing a list of |
FieldsEntry
| JSON representation |
|---|
{ "key": string, "value": value } |
| Fields | |
|---|---|
key |
|
value |
|
Value
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field kind. The kind of value. kind can be only one of the following: |
|
nullValue |
Represents a JSON |
numberValue |
Represents a JSON number. Must not be |
stringValue |
Represents a JSON string. |
boolValue |
Represents a JSON boolean ( |
structValue |
Represents a JSON object. |
listValue |
Represents a JSON array. |
ListValue
| JSON representation |
|---|
{ "values": [ value ] } |
| Fields | |
|---|---|
values[] |
Repeated field of dynamically typed values. |
TimePartitioning
| JSON representation |
|---|
{ "type": string, "expirationMs": string, "field": string, "requirePartitionFilter": boolean } |
| Fields | |
|---|---|
type |
Required. The supported types are DAY, HOUR, MONTH, and YEAR, which will generate one partition per day, hour, month, and year, respectively. |
expirationMs |
Optional. Number of milliseconds for which to keep the storage for a partition. A wrapper is used here because 0 is an invalid value. |
field |
Optional. If not set, the table is partitioned by pseudo column '_PARTITIONTIME'; if set, the table is partitioned by this field. The field must be a top-level TIMESTAMP or DATE field. Its mode must be NULLABLE or REQUIRED. A wrapper is used here because an empty string is an invalid value. |
requirePartitionFilter |
If set to true, queries over this table require a partition filter that can be used for partition elimination to be specified. This field is deprecated; please set the field with the same name on the table itself instead. This field needs a wrapper because we want to output the default value, false, if the user explicitly set it. |
RangePartitioning
| JSON representation |
|---|
{
"field": string,
"range": {
object ( |
| Fields | |
|---|---|
field |
Required. The name of the column to partition the table on. It must be a top-level, INT64 column whose mode is NULLABLE or REQUIRED. |
range |
Defines the ranges for range partitioning. |
Range
| JSON representation |
|---|
{ "start": string, "end": string, "interval": string } |
| Fields | |
|---|---|
start |
Required. The start of range partitioning, inclusive. This field is an INT64 value represented as a string. |
end |
Required. The end of range partitioning, exclusive. This field is an INT64 value represented as a string. |
interval |
Required. The width of each interval. This field is an INT64 value represented as a string. |
Clustering
| JSON representation |
|---|
{ "fields": [ string ] } |
| Fields | |
|---|---|
fields[] |
One or more fields on which data should be clustered. Only top-level, non-repeated, simple-type fields are supported. The ordering of the clustering fields should be prioritized from most to least important for filtering purposes. For additional information, see Introduction to clustered tables. |
EncryptionConfiguration
| JSON representation |
|---|
{ "kmsKeyName": string } |
| Fields | |
|---|---|
kmsKeyName |
Optional. Describes the Cloud KMS encryption key that will be used to protect destination BigQuery table. The BigQuery Service Account associated with your project requires access to this encryption key. |
ScriptOptions
| JSON representation |
|---|
{
"statementTimeoutMs": string,
"statementByteBudget": string,
"keyResultStatement": enum ( |
| Fields | |
|---|---|
statementTimeoutMs |
Timeout period for each statement in a script. |
statementByteBudget |
Limit on the number of bytes billed per statement. Exceeding this budget results in an error. |
keyResultStatement |
Determines which statement in the script represents the "key result", used to populate the schema and query results of the script job. Default is LAST. |
ConnectionProperty
| JSON representation |
|---|
{ "key": string, "value": string } |
| Fields | |
|---|---|
key |
The key of the property to set. |
value |
The value of the property to set. |
SecureContext
| JSON representation |
|---|
{ "secureParameterEntries": { object } } |
| Fields | |
|---|---|
secureParameterEntries |
Optional. A set of key-value pairs representing the secure parameter values. They can be retrieved via the SECURE_CONTEXT() function and used to modify the run-time behavior of a query. |
JobConfigurationLoad
| JSON representation |
|---|
{ "sourceUris": [ string ], "fileSetSpecType": enum ( |
| Fields | |
|---|---|
sourceUris[] |
[Required] The fully-qualified URIs that point to your data in Google Cloud. For Google Cloud Storage URIs: Each URI can contain one '*' wildcard character and it must come after the 'bucket' name. Size limits related to load jobs apply to external data sources. For Google Cloud Bigtable URIs: Exactly one URI can be specified and it has be a fully specified and valid HTTPS URL for a Google Cloud Bigtable table. For Google Cloud Datastore backups: Exactly one URI can be specified. Also, the '*' wildcard character is not allowed. |
fileSetSpecType |
Optional. Specifies how source URIs are interpreted for constructing the file set to load. By default, source URIs are expanded against the underlying storage. You can also specify manifest files to control how the file set is constructed. This option is only applicable to object storage systems. |
schema |
Optional. The schema for the destination table. The schema can be omitted if the destination table already exists, or if you're loading data from Google Cloud Datastore. |
destinationTable |
[Required] The destination table to load the data into. |
destinationTableProperties |
Optional. [Experimental] Properties with which to create the destination table if it is new. |
createDisposition |
Optional. Specifies whether the job is allowed to create new tables. The following values are supported:
|
writeDisposition |
Optional. Specifies the action that occurs if the destination table already exists. The following values are supported:
The default value is WRITE_APPEND. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion. |
nullMarker |
Optional. Specifies a string that represents a null value in a CSV file. For example, if you specify "\N", BigQuery interprets "\N" as a null value when loading a CSV file. The default value is the empty string. If you set this property to a custom value, BigQuery throws an error if an empty string is present for all data types except for STRING and BYTE. For STRING and BYTE columns, BigQuery interprets the empty string as an empty value. |
fieldDelimiter |
Optional. The separator character for fields in a CSV file. The separator is interpreted as a single byte. For files encoded in ISO-8859-1, any single character can be used as a separator. For files encoded in UTF-8, characters represented in decimal range 1-127 (U+0001-U+007F) can be used without any modification. UTF-8 characters encoded with multiple bytes (i.e. U+0080 and above) will have only the first byte used for separating fields. The remaining bytes will be treated as a part of the field. BigQuery also supports the escape sequence "\t" (U+0009) to specify a tab separator. The default value is comma (",", U+002C). |
skipLeadingRows |
Optional. The number of rows at the top of a CSV file that BigQuery will skip when loading the data. The default value is 0. This property is useful if you have header rows in the file that should be skipped. When autodetect is on, the behavior is the following:
|
encoding |
Optional. The character encoding of the data. The supported values are UTF-8, ISO-8859-1, UTF-16BE, UTF-16LE, UTF-32BE, and UTF-32LE. The default value is UTF-8. BigQuery decodes the data after the raw, binary data has been split using the values of the If you don't specify an encoding, or if you specify a UTF-8 encoding when the CSV file is not UTF-8 encoded, BigQuery attempts to convert the data to UTF-8. Generally, your data loads successfully, but it may not match byte-for-byte what you expect. To avoid this, specify the correct encoding by using the If BigQuery can't convert a character other than the ASCII |
quote |
Optional. The value that is used to quote data sections in a CSV file. BigQuery converts the string to ISO-8859-1 encoding, and then uses the first byte of the encoded string to split the data in its raw, binary state. The default value is a double-quote ('"'). If your data does not contain quoted sections, set the property value to an empty string. If your data contains quoted newline characters, you must also set the allowQuotedNewlines property to true. To include the specific quote character within a quoted value, precede it with an additional matching quote character. For example, if you want to escape the default character ' " ', use ' "" '. @default " |
maxBadRecords |
Optional. The maximum number of bad records that BigQuery can ignore when running the job. If the number of bad records exceeds this value, an invalid error is returned in the job result. The default value is 0, which requires that all records are valid. This is only supported for CSV and NEWLINE_DELIMITED_JSON file formats. |
schemaInlineFormat |
[Deprecated] The format of the schemaInline property. |
schemaInline |
[Deprecated] The inline schema. For CSV schemas, specify as "Field1:Type1[,Field2:Type2]*". For example, "foo:STRING, bar:INTEGER, baz:FLOAT". |
allowQuotedNewlines |
Indicates if BigQuery should allow quoted data sections that contain newline characters in a CSV file. The default value is false. |
sourceFormat |
Optional. The format of the data files. For CSV files, specify "CSV". For datastore backups, specify "DATASTORE_BACKUP". For newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON". For Avro, specify "AVRO". For parquet, specify "PARQUET". For orc, specify "ORC". The default value is CSV. |
allowJaggedRows |
Optional. Accept rows that are missing trailing optional columns. The missing values are treated as nulls. If false, records with missing trailing columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. Only applicable to CSV, ignored for other formats. |
ignoreUnknownValues |
Optional. Indicates if BigQuery should allow extra values that are not represented in the table schema. If true, the extra values are ignored. If false, records with extra columns are treated as bad records, and if there are too many bad records, an invalid error is returned in the job result. The default value is false. The sourceFormat property determines what BigQuery treats as an extra value: CSV: Trailing columns JSON: Named values that don't match any column names in the table schema Avro, Parquet, ORC: Fields in the file schema that don't exist in the table schema. |
projectionFields[] |
If sourceFormat is set to "DATASTORE_BACKUP", indicates which entity properties to load into BigQuery from a Cloud Datastore backup. Property names are case sensitive and must be top-level properties. If no properties are specified, BigQuery loads all properties. If any named property isn't found in the Cloud Datastore backup, an invalid error is returned in the job result. |
autodetect |
Optional. Indicates if we should automatically infer the options and schema for CSV and JSON sources. |
schemaUpdateOptions[] |
Allows the schema of the destination table to be updated as a side effect of the load job if a schema is autodetected or supplied in the job configuration. Schema update options are supported in three cases: when writeDisposition is WRITE_APPEND; when writeDisposition is WRITE_TRUNCATE_DATA; when writeDisposition is WRITE_TRUNCATE and the destination table is a partition of a table, specified by partition decorators. For normal tables, WRITE_TRUNCATE will always overwrite the schema. One or more of the following values are specified:
|
timePartitioning |
Time-based partitioning specification for the destination table. Only one of timePartitioning and rangePartitioning should be specified. |
rangePartitioning |
Range partitioning specification for the destination table. Only one of timePartitioning and rangePartitioning should be specified. |
clustering |
Clustering specification for the destination table. |
destinationEncryptionConfiguration |
Custom encryption configuration (e.g., Cloud KMS keys) |
useAvroLogicalTypes |
Optional. If sourceFormat is set to "AVRO", indicates whether to interpret logical types as the corresponding BigQuery data type (for example, TIMESTAMP), instead of using the raw type (for example, INTEGER). |
referenceFileSchemaUri |
Optional. The user can provide a reference file with the reader schema. This file is only loaded if it is part of source URIs, but is not loaded otherwise. It is enabled for the following formats: AVRO, PARQUET, ORC. |
hivePartitioningOptions |
Optional. When set, configures hive partitioning support. Not all storage formats support hive partitioning -- requesting hive partitioning on an unsupported format will lead to an error, as will providing an invalid specification. |
decimalTargetTypes[] |
Defines the list of possible SQL data types to which the source decimal values are converted. This list and the precision and the scale parameters of the decimal field determine the target type. In the order of NUMERIC, BIGNUMERIC, and STRING, a type is picked if it is in the specified list and if it supports the precision and the scale. STRING supports all precision and scale values. If none of the listed types supports the precision and the scale, the type supporting the widest range in the specified list is picked, and if a value exceeds the supported range when reading the data, an error will be thrown. Example: Suppose the value of this field is ["NUMERIC", "BIGNUMERIC"]. If (precision,scale) is:
This field cannot contain duplicate types. The order of the types in this field is ignored. For example, ["BIGNUMERIC", "NUMERIC"] is the same as ["NUMERIC", "BIGNUMERIC"] and NUMERIC always takes precedence over BIGNUMERIC. Defaults to ["NUMERIC", "STRING"] for ORC and ["NUMERIC"] for the other file formats. |
thriftOptions |
Optional. [Experimental] The load options for Apache Thrift serialized data. It defines the source of IDL bundle that should be used to be parsed as the schema and deserialization options to parse Thrift data. |
jsonExtension |
Optional. Load option to be used together with source_format newline-delimited JSON to indicate that a variant of JSON is being loaded. To load newline-delimited GeoJSON, specify GEOJSON (and source_format must be set to NEWLINE_DELIMITED_JSON). |
parquetOptions |
Optional. Additional properties to set if sourceFormat is set to PARQUET. |
preserveAsciiControlCharacters |
Optional. When sourceFormat is set to "CSV", this indicates whether the embedded ASCII control characters (the first 32 characters in the ASCII-table, from '\x00' to '\x1F') are preserved. |
connectionProperties[] |
Optional. Connection properties which can modify the load job behavior. Currently, only the 'session_id' connection property is supported, and is used to resolve _SESSION appearing as the dataset id. |
createSession |
Optional. If this property is true, the job creates a new session using a randomly generated session_id. To continue using a created session with subsequent queries, pass the existing session identifier as a The new session's location will be set to |
columnNameCharacterMap |
Optional. Character map supported for column names in CSV/Parquet loads. Defaults to STRICT and can be overridden by Project Config Service. Using this option with unsupporting load formats will result in an error. |
copyFilesOnly |
Optional. [Experimental] Configures the load job to copy files directly to the destination BigLake managed table, bypassing file content reading and rewriting. Copying files only is supported when all the following are true:
|
timeZone |
Optional. Default time zone that will apply when parsing timestamp values that have no specific time zone. |
nullMarkers[] |
Optional. A list of strings represented as SQL NULL value in a CSV file. null_marker and null_markers can't be set at the same time. If null_marker is set, null_markers has to be not set. If null_markers is set, null_marker has to be not set. If both null_marker and null_markers are set at the same time, a user error would be thrown. Any strings listed in null_markers, including empty string would be interpreted as SQL NULL. This applies to all column types. |
sourceColumnMatch |
Optional. Controls the strategy used to match loaded columns to the schema. If not set, a sensible default is chosen based on how the schema is provided. If autodetect is used, then columns are matched by name. Otherwise, columns are matched by position. This is done to keep the behavior backward-compatible. |
timestampTargetPrecision[] |
Precisions (maximum number of total digits in base 10) for seconds of TIMESTAMP types that are allowed to the destination table for autodetection mode. Available for the formats: CSV, PARQUET, AVRO, and Iceberg External Table. Possible values include: Not Specified, [], or [6]: timestamp(6) for all auto detected TIMESTAMP columns [6, 12]: timestamp(6) for all auto detected TIMESTAMP columns that have less than 6 digits of subseconds. timestamp(12) for all auto detected TIMESTAMP columns that have more than 6 digits of subseconds. [12]: timestamp(12) for all auto detected TIMESTAMP columns. The order of the elements in this array is ignored. Inputs that have higher precision than the highest target precision in this array will be truncated. |
Union field
|
|
dateFormat |
Optional. Date format used for parsing DATE values. |
Union field
|
|
datetimeFormat |
Optional. Date format used for parsing DATETIME values. |
Union field
|
|
timeFormat |
Optional. Date format used for parsing TIME values. |
Union field
|
|
timestampFormat |
Optional. Date format used for parsing TIMESTAMP values. |
DestinationTableProperties
| JSON representation |
|---|
{ "friendlyName": string, "description": string, "labels": { string: string, ... } } |
| Fields | |
|---|---|
friendlyName |
Optional. Friendly name for the destination table. If the table already exists, it should be same as the existing friendly name. |
description |
Optional. The description for the destination table. This will only be used if the destination table is newly created. If the table already exists and a value different than the current description is provided, the job will fail. |
labels |
Optional. The labels associated with this table. You can use these to organize and group your tables. This will only be used if the destination table is newly created. If the table already exists and labels are different than the current labels are provided, the job will fail. An object containing a list of |
LabelsEntry
| JSON representation |
|---|
{ "key": string, "value": string } |
| Fields | |
|---|---|
key |
|
value |
|
ThriftOptions
| JSON representation |
|---|
{ "schemaIdlRootDir": string, "schemaIdlUri": string, "schemaStruct": string, "deserializationOption": enum ( |
| Fields | |
|---|---|
schemaIdlRootDir |
Required. The root directory of the IDL file bundle defining the schema. All IDL files that are used to parse the schema should be in this directory. This directory should be different from the source_uris. |
schemaIdlUri |
Required. The Thrift IDL file in the |
schemaStruct |
Required. The root struct specified in |
deserializationOption |
Optional.
|
framingOption |
Optional. Framing in Thrift means 4 bytes slipped in front of the serialized record or data block to inidicate the size of the followed record or data block. The following options are support:
One option to frame Thrift record at serialization time is using |
boundaryBytes |
Optional. Sequence of bytes used to separate two serialized Thrift data blocks. When it's used with A base64-encoded string. |
JobConfigurationTableCopy
| JSON representation |
|---|
{ "sourceTable": { object ( |
| Fields | |
|---|---|
sourceTable |
[Pick one] Source table to copy. |
sourceTables[] |
[Pick one] Source tables to copy. |
destinationTable |
[Required] The destination table. |
createDisposition |
Optional. Specifies whether the job is allowed to create new tables. The following values are supported:
The default value is CREATE_IF_NEEDED. Creation, truncation and append actions occur as one atomic update upon job completion. |
writeDisposition |
Optional. Specifies the action that occurs if the destination table already exists. The following values are supported:
The default value is WRITE_EMPTY. Each action is atomic and only occurs if BigQuery is able to complete the job successfully. Creation, truncation and append actions occur as one atomic update upon job completion. |
destinationEncryptionConfiguration |
Custom encryption configuration (e.g., Cloud KMS keys). |
operationType |
Optional. Supported operation types in table copy job. |
destinationExpirationTime |
Optional. The time when the destination table expires. Expired tables will be deleted and their storage reclaimed. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: |
Timestamp
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z). |
nanos |
Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive. |
JobConfigurationExtract
| JSON representation |
|---|
{ "destinationUri": string, "destinationUris": [ string ], "printHeader": boolean, "fieldDelimiter": string, "destinationFormat": string, "compression": string, "useAvroLogicalTypes": boolean, "modelExtractOptions": { object ( |
| Fields | |
|---|---|
destinationUri |
[Pick one] DEPRECATED: Use destinationUris instead, passing only one URI as necessary. The fully-qualified Google Cloud Storage URI where the extracted table should be written. |
destinationUris[] |
[Pick one] A list of fully-qualified Google Cloud Storage URIs where the extracted table should be written. |
printHeader |
Optional. Whether to print out a header row in the results. Default is true. Not applicable when extracting models. |
fieldDelimiter |
Optional. When extracting data in CSV format, this defines the delimiter to use between fields in the exported data. Default is ','. Not applicable when extracting models. |
destinationFormat |
Optional. The exported file format. Possible values include CSV, NEWLINE_DELIMITED_JSON, PARQUET, or AVRO for tables and ML_TF_SAVED_MODEL or ML_XGBOOST_BOOSTER for models. The default value for tables is CSV. Tables with nested or repeated fields cannot be exported as CSV. The default value for models is ML_TF_SAVED_MODEL. |
compression |
Optional. The compression type to use for exported files. Possible values include DEFLATE, GZIP, NONE, SNAPPY, and ZSTD. The default value is NONE. Not all compression formats are support for all file formats. DEFLATE is only supported for Avro. ZSTD is only supported for Parquet. Not applicable when extracting models. |
useAvroLogicalTypes |
Whether to use logical types when extracting to AVRO format. Not applicable when extracting models. |
modelExtractOptions |
Optional. Model extract options only applicable when extracting models. |
nativeGeographyExportEnabled |
Optional. Applicable to formats: PARQUET. If enabled, BigQuery to Parquet export will write the native Parquet Geography type instead of the default GeoParquet type. |
Union field source. Required. Source reference for the export. source can be only one of the following: |
|
sourceTable |
A reference to the table being exported. |
sourceModel |
A reference to the model being exported. |
ModelReference
| JSON representation |
|---|
{ "projectId": string, "datasetId": string, "modelId": string } |
| Fields | |
|---|---|
projectId |
Required. The ID of the project containing this model. |
datasetId |
Required. The ID of the dataset containing this model. |
modelId |
Required. The ID of the model. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 1,024 characters. |
ModelExtractOptions
| JSON representation |
|---|
{ "trialId": string } |
| Fields | |
|---|---|
trialId |
The 1-based ID of the trial to be exported from a hyperparameter tuning model. If not specified, the trial with id = Model.defaultTrialId is exported. This field is ignored for models not trained with hyperparameter tuning. |
LabelsEntry
| JSON representation |
|---|
{ "key": string, "value": string } |
| Fields | |
|---|---|
key |
|
value |
|
JobReference
| JSON representation |
|---|
{ "projectId": string, "jobId": string, "location": string } |
| Fields | |
|---|---|
projectId |
Required. The ID of the project containing this job. |
jobId |
Required. The ID of the job. The ID must contain only letters (a-z, A-Z), numbers (0-9), underscores (_), or dashes (-). The maximum length is 1,024 characters. |
location |
Optional. The geographic location of the job. The default value is US. For more information about BigQuery locations, see: https://cloud.google.com/bigquery/docs/locations |
JobStatistics
| JSON representation |
|---|
{ "creationTime": string, "startTime": string, "endTime": string, "totalBytesProcessed": string, "completionRatio": number, "quotaDeferments": [ string ], "query": { object ( |
| Fields | |
|---|---|
creationTime |
Output only. Creation time of this job, in milliseconds since the epoch. This field will be present on all jobs. |
startTime |
Output only. Start time of this job, in milliseconds since the epoch. This field will be present when the job transitions from the PENDING state to either RUNNING or DONE. |
endTime |
Output only. End time of this job, in milliseconds since the epoch. This field will be present whenever a job is in the DONE state. |
totalBytesProcessed |
Output only. Total bytes processed for the job. |
completionRatio |
Output only. [TrustedTester] Job progress (0.0 -> 1.0) for LOAD and EXTRACT jobs. |
quotaDeferments[] |
Output only. Quotas which delayed this job's start time. |
query |
Output only. Statistics for a query job. |
load |
Output only. Statistics for a load job. |
extract |
Output only. Statistics for an extract job. |
copy |
Output only. Statistics for a copy job. |
totalSlotMs |
Output only. Slot-milliseconds for the job. |
reservationUsage[] |
Output only. Job resource usage breakdown by reservation. This field reported misleading information and will no longer be populated. |
reservation_id |
Output only. Name of the primary reservation assigned to this job. Note that this could be different than reservations reported in the reservation usage field if parent reservations were used to execute this job. |
numChildJobs |
Output only. Number of child jobs executed. |
parentJobId |
Output only. If this is a child job, specifies the job ID of the parent. |
scriptStatistics |
Output only. If this a child job of a script, specifies information about the context of this job within the script. |
rowLevelSecurityStatistics |
Output only. Statistics for row-level security. Present only for query and extract jobs. |
dataMaskingStatistics |
Output only. Statistics for data-masking. Present only for query and extract jobs. |
transactionInfo |
Output only. [Alpha] Information of the multi-statement transaction if this job is part of one. This property is only expected on a child job or a job that is in a session. A script parent job is not part of the transaction started in the script. |
sessionInfo |
Output only. Information of the session if this job is part of one. |
finalExecutionDurationMs |
Output only. The duration in milliseconds of the execution of the final attempt of this job, as BigQuery may internally re-attempt to execute the job. |
edition |
Output only. Name of edition corresponding to the reservation for this job at the time of this update. |
reservationGroupPath[] |
Output only. The reservation group path of the reservation assigned to this job. This field has a limit of 10 nested reservation groups. This is to maintain consistency between reservations info schema and jobs info schema. The first reservation group is the root reservation group and the last is the leaf or lowest level reservation group. |
globalQueryRemoteRegions[] |
Output only. The list of remote regions from which a global query accesses data. This field is populated only for parent global query jobs in the primary execution region. It is empty for child global query jobs and single-region queries. For more information, see Global queries. |
parentGlobalQueryJob |
Output only. Reference to the parent global query job, if this is a child global query job. This field is populated only for child global query jobs (remote subqueries or cross-region table copy jobs) executed in remote regions on behalf of a global query. It contains the project ID, job ID, and location of the parent global query job. It is unset for parent global query jobs and single-region queries. For more information, see Global queries. |
DoubleValue
| JSON representation |
|---|
{ "value": number } |
| Fields | |
|---|---|
value |
The double value. |
JobStatistics2
| JSON representation |
|---|
{ "queryPlan": [ { object ( |
| Fields | |
|---|---|
queryPlan[] |
Output only. Describes execution plan for the query. |
estimatedBytesProcessed |
Output only. The original estimate of bytes processed for the job. |
timeline[] |
Output only. Describes a timeline of job execution. |
totalPartitionsProcessed |
Output only. Total number of partitions processed from all partitioned tables referenced in the job. |
totalBytesProcessed |
Output only. Total bytes processed for the job. |
totalBytesProcessedAccuracy |
Output only. For dry-run jobs, totalBytesProcessed is an estimate and this field specifies the accuracy of the estimate. Possible values can be: UNKNOWN: accuracy of the estimate is unknown. PRECISE: estimate is precise. LOWER_BOUND: estimate is lower bound of what the query would cost. UPPER_BOUND: estimate is upper bound of what the query would cost. |
totalBytesBilled |
Output only. If the project is configured to use on-demand pricing, then this field contains the total bytes billed for the job. If the project is configured to use flat-rate pricing, then you are not billed for bytes and this field is informational only. |
billingTier |
Output only. Billing tier for the job. This is a BigQuery-specific concept which is not related to the Google Cloud notion of "free tier". The value here is a measure of the query's resource consumption relative to the amount of data scanned. For on-demand queries, the limit is 100, and all queries within this limit are billed at the standard on-demand rates. On-demand queries that exceed this limit will fail with a billingTierLimitExceeded error. |
totalSlotMs |
Output only. Slot-milliseconds for the job. |
reservationUsage[] |
Output only. Job resource usage breakdown by reservation. This field reported misleading information and will no longer be populated. |
cacheHit |
Output only. Whether the query result was fetched from the query cache. |
referencedTables[] |
Output only. Referenced tables for the job. |
referencedRoutines[] |
Output only. Referenced routines for the job. |
referencedPropertyGraphs[] |
Output only. Referenced property graphs for the job. Queries that reference more than 50 property graphs will not have a complete list. |
schema |
Output only. The schema of the results. Present only for successful dry run of non-legacy SQL queries. |
numDmlAffectedRows |
Output only. The number of rows affected by a DML statement. Present only for DML statements INSERT, UPDATE or DELETE. |
dmlStats |
Output only. Detailed statistics for DML statements INSERT, UPDATE, DELETE, MERGE or TRUNCATE. |
undeclaredQueryParameters[] |
Output only. GoogleSQL only: list of undeclared query parameters detected during a dry run validation. |
statementType |
Output only. The type of query statement, if valid. Possible values:
|
ddlOperationPerformed |
Output only. The DDL operation performed, possibly dependent on the pre-existence of the DDL target. |
ddlTargetTable |
Output only. The DDL target table. Present only for CREATE/DROP TABLE/VIEW and DROP ALL ROW ACCESS POLICIES queries. |
ddlDestinationTable |
Output only. The table after rename. Present only for ALTER TABLE RENAME TO query. |
ddlTargetRowAccessPolicy |
Output only. The DDL target row access policy. Present only for CREATE/DROP ROW ACCESS POLICY queries. |
ddlAffectedRowAccessPolicyCount |
Output only. The number of row access policies affected by a DDL statement. Present only for DROP ALL ROW ACCESS POLICIES queries. |
ddlTargetRoutine |
Output only. [Beta] The DDL target routine. Present only for CREATE/DROP FUNCTION/PROCEDURE queries. |
ddlTargetDataset |
Output only. The DDL target dataset. Present only for CREATE/ALTER/DROP SCHEMA(dataset) queries. |
mlStatistics |
Output only. Statistics of a BigQuery ML training job. |
exportDataStatistics |
Output only. Stats for EXPORT DATA statement. |
externalServiceCosts[] |
Output only. Job cost breakdown as bigquery internal cost and external service costs. |
biEngineStatistics |
Output only. BI Engine specific Statistics. |
loadQueryStatistics |
Output only. Statistics for a LOAD query. |
dclTargetTable |
Output only. Referenced table for DCL statement. |
dclTargetView |
Output only. Referenced view for DCL statement. |
dclTargetDataset |
Output only. Referenced dataset for DCL statement. |
searchStatistics |
Output only. Search query specific statistics. |
vectorSearchStatistics |
Output only. Vector Search query specific statistics. |
performanceInsights |
Output only. Performance insights. |
queryInfo |
Output only. Query optimization information for a QUERY job. |
sparkStatistics |
Output only. Statistics of a Spark procedure job. |
transferredBytes |
Output only. Total bytes transferred for BigQuery Omni queries from the remote cloud back to Google Cloud. This tracks data movement over Google-managed connections (like query results). It doesn't include input data read from the external data lake (for example, S3) because that data stays within the remote cloud. |
materializedViewStatistics |
Output only. Statistics of materialized views of a query job. |
metadataCacheStatistics |
Output only. Statistics of metadata cache usage in a query for BigLake tables. |
incrementalResultStats |
Output only. Statistics related to incremental query results, if enabled for the query. This feature is not yet available. |
genAiStats |
Output only. Statistics related to GenAI usage in the query. |
objectStorageStats[] |
Output only. Storage and caching statistics per cloud provider for queries over object storage. |
Union field
|
|
totalServicesSkuSlotMs |
Output only. Total slot milliseconds for the job that ran on external services and billed on the services SKU. This field is only populated for jobs that have external service costs, and is the total of the usage for costs whose billing method is |
ExplainQueryStage
| JSON representation |
|---|
{ "name": string, "id": string, "startMs": string, "endMs": string, "inputStages": [ string ], "waitRatioAvg": number, "waitMsAvg": string, "waitRatioMax": number, "waitMsMax": string, "readRatioAvg": number, "readMsAvg": string, "readRatioMax": number, "readMsMax": string, "computeRatioAvg": number, "computeMsAvg": string, "computeRatioMax": number, "computeMsMax": string, "writeRatioAvg": number, "writeMsAvg": string, "writeRatioMax": number, "writeMsMax": string, "shuffleOutputBytes": string, "shuffleOutputBytesSpilled": string, "recordsRead": string, "recordsWritten": string, "parallelInputs": string, "completedParallelInputs": string, "status": string, "steps": [ { object ( |
| Fields | |
|---|---|
name |
Human-readable name for the stage. |
id |
Unique ID for the stage within the plan. |
startMs |
Stage start time represented as milliseconds since the epoch. |
endMs |
Stage end time represented as milliseconds since the epoch. |
inputStages[] |
IDs for stages that are inputs to this stage. |
waitRatioAvg |
Relative amount of time the average shard spent waiting to be scheduled. |
waitMsAvg |
Milliseconds the average shard spent waiting to be scheduled. |
waitRatioMax |
Relative amount of time the slowest shard spent waiting to be scheduled. |
waitMsMax |
Milliseconds the slowest shard spent waiting to be scheduled. |
readRatioAvg |
Relative amount of time the average shard spent reading input. |
readMsAvg |
Milliseconds the average shard spent reading input. |
readRatioMax |
Relative amount of time the slowest shard spent reading input. |
readMsMax |
Milliseconds the slowest shard spent reading input. |
computeRatioAvg |
Relative amount of time the average shard spent on CPU-bound tasks. |
computeMsAvg |
Milliseconds the average shard spent on CPU-bound tasks. |
computeRatioMax |
Relative amount of time the slowest shard spent on CPU-bound tasks. |
computeMsMax |
Milliseconds the slowest shard spent on CPU-bound tasks. |
writeRatioAvg |
Relative amount of time the average shard spent on writing output. |
writeMsAvg |
Milliseconds the average shard spent on writing output. |
writeRatioMax |
Relative amount of time the slowest shard spent on writing output. |
writeMsMax |
Milliseconds the slowest shard spent on writing output. |
shuffleOutputBytes |
Total number of bytes written to shuffle. |
shuffleOutputBytesSpilled |
Total number of bytes written to shuffle and spilled to disk. |
recordsRead |
Number of records read into the stage. |
recordsWritten |
Number of records written by the stage. |
parallelInputs |
Number of parallel input segments to be processed |
completedParallelInputs |
Number of parallel input segments completed. |
status |
Current status for this stage. |
steps[] |
List of operations within the stage in dependency order (approximately chronological). |
slotMs |
Slot-milliseconds used by the stage. |
computeMode |
Output only. Compute mode for this stage. |
ExplainQueryStep
| JSON representation |
|---|
{ "kind": string, "substeps": [ string ] } |
| Fields | |
|---|---|
kind |
Machine-readable operation type. |
substeps[] |
Human-readable description of the step(s). |
QueryTimelineSample
| JSON representation |
|---|
{ "elapsedMs": string, "totalSlotMs": string, "pendingUnits": string, "completedUnits": string, "activeUnits": string, "shuffleRamUsageRatio": number, "estimatedRunnableUnits": string } |
| Fields | |
|---|---|
elapsedMs |
Milliseconds elapsed since the start of query execution. |
totalSlotMs |
Cumulative slot-ms consumed by the query. |
pendingUnits |
Total units of work remaining for the query. This number can be revised (increased or decreased) while the query is running. |
completedUnits |
Total parallel units of work completed by this query. |
activeUnits |
Total number of active workers. This does not correspond directly to slot usage. This is the largest value observed since the last sample. |
shuffleRamUsageRatio |
Total shuffle usage ratio in shuffle RAM per reservation of this query. This will be provided for reservation customers only. |
estimatedRunnableUnits |
Units of work that can be scheduled immediately. Providing additional slots for these units of work will accelerate the query, if no other query in the reservation needs additional slots. |
ReservationResourceUsage
| JSON representation |
|---|
{ "name": string, "slotMs": string } |
| Fields | |
|---|---|
name |
Reservation name or "unreserved" for on-demand resource usage and multi-statement queries. |
slotMs |
Total slot milliseconds used by the reservation for a particular job. |
RoutineReference
| JSON representation |
|---|
{ "projectId": string, "datasetId": string, "routineId": string } |
| Fields | |
|---|---|
projectId |
Required. The ID of the project containing this routine. |
datasetId |
Required. The ID of the dataset containing this routine. |
routineId |
Required. The ID of the routine. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 256 characters. |
PropertyGraphReference
| JSON representation |
|---|
{ "projectId": string, "datasetId": string, "propertyGraphId": string } |
| Fields | |
|---|---|
projectId |
Required. The ID of the project containing this property graph. |
datasetId |
Required. The ID of the dataset containing this property graph. |
propertyGraphId |
Required. The ID of the property graph. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 256 characters. |
DmlStats
| JSON representation |
|---|
{ "insertedRowCount": string, "deletedRowCount": string, "updatedRowCount": string, "dmlMode": enum ( |
| Fields | |
|---|---|
insertedRowCount |
Output only. Number of inserted Rows. Populated by DML INSERT and MERGE statements |
deletedRowCount |
Output only. Number of deleted Rows. populated by DML DELETE, MERGE and TRUNCATE statements. |
updatedRowCount |
Output only. Number of updated Rows. Populated by DML UPDATE and MERGE statements. |
dmlMode |
Output only. DML mode used. |
fineGrainedDmlUnusedReason |
Output only. Reason for disabling fine-grained DML if applicable. |
RowAccessPolicyReference
| JSON representation |
|---|
{ "projectId": string, "datasetId": string, "tableId": string, "policyId": string } |
| Fields | |
|---|---|
projectId |
Required. The ID of the project containing this row access policy. |
datasetId |
Required. The ID of the dataset containing this row access policy. |
tableId |
Required. The ID of the table containing this row access policy. |
policyId |
Required. The ID of the row access policy. The ID must contain only letters (a-z, A-Z), numbers (0-9), or underscores (_). The maximum length is 256 characters. |
MlStatistics
| JSON representation |
|---|
{ "maxIterations": string, "iterationResults": [ { object ( |
| Fields | |
|---|---|
maxIterations |
Output only. Maximum number of iterations specified as max_iterations in the 'CREATE MODEL' query. The actual number of iterations may be less than this number due to early stop. |
iterationResults[] |
Results for all completed iterations. Empty for hyperparameter tuning jobs. |
modelType |
Output only. The type of the model that is being trained. |
trainingType |
Output only. Training type of the job. |
hparamTrials[] |
Output only. Trials of a hyperparameter tuning job sorted by trial_id. |
IterationResult
| JSON representation |
|---|
{ "index": integer, "durationMs": string, "trainingLoss": number, "evalLoss": number, "learnRate": number, "clusterInfos": [ { object ( |
| Fields | |
|---|---|
index |
Index of the iteration, 0 based. |
durationMs |
Time taken to run the iteration in milliseconds. |
trainingLoss |
Loss computed on the training data at the end of iteration. |
evalLoss |
Loss computed on the eval data at the end of iteration. |
learnRate |
Learn rate used for this iteration. |
clusterInfos[] |
Information about top clusters for clustering models. |
arimaResult |
Arima result. |
principalComponentInfos[] |
The information of the principal components. |
ClusterInfo
| JSON representation |
|---|
{ "centroidId": string, "clusterRadius": number, "clusterSize": string } |
| Fields | |
|---|---|
centroidId |
Centroid id. |
clusterRadius |
Cluster radius, the average distance from centroid to each point assigned to the cluster. |
clusterSize |
Cluster size, the total number of points assigned to the cluster. |
ArimaResult
| JSON representation |
|---|
{ "arimaModelInfo": [ { object ( |
| Fields | |
|---|---|
arimaModelInfo[] |
This message is repeated because there are multiple arima models fitted in auto-arima. For non-auto-arima model, its size is one. |
seasonalPeriods[] |
Seasonal periods. Repeated because multiple periods are supported for one time series. |
ArimaModelInfo
| JSON representation |
|---|
{ "nonSeasonalOrder": { object ( |
| Fields | |
|---|---|
nonSeasonalOrder |
Non-seasonal order. |
arimaCoefficients |
Arima coefficients. |
arimaFittingMetrics |
Arima fitting metrics. |
hasDrift |
Whether Arima model fitted with drift or not. It is always false when d is not 1. |
timeSeriesId |
The time_series_id value for this time series. It will be one of the unique values from the time_series_id_column specified during ARIMA model training. Only present when time_series_id_column training option was used. |
timeSeriesIds[] |
The tuple of time_series_ids identifying this time series. It will be one of the unique tuples of values present in the time_series_id_columns specified during ARIMA model training. Only present when time_series_id_columns training option was used and the order of values here are same as the order of time_series_id_columns. |
seasonalPeriods[] |
Seasonal periods. Repeated because multiple periods are supported for one time series. |
hasHolidayEffect |
If true, holiday_effect is a part of time series decomposition result. |
hasSpikesAndDips |
If true, spikes_and_dips is a part of time series decomposition result. |
hasStepChanges |
If true, step_changes is a part of time series decomposition result. |
ArimaOrder
| JSON representation |
|---|
{ "p": string, "d": string, "q": string } |
| Fields | |
|---|---|
p |
Order of the autoregressive part. |
d |
Order of the differencing part. |
q |
Order of the moving-average part. |
ArimaCoefficients
| JSON representation |
|---|
{ "autoRegressiveCoefficients": [ number ], "movingAverageCoefficients": [ number ], "interceptCoefficient": number } |
| Fields | |
|---|---|
autoRegressiveCoefficients[] |
Auto-regressive coefficients, an array of double. |
movingAverageCoefficients[] |
Moving-average coefficients, an array of double. |
interceptCoefficient |
Intercept coefficient, just a double not an array. |
ArimaFittingMetrics
| JSON representation |
|---|
{ "logLikelihood": number, "aic": number, "variance": number } |
| Fields | |
|---|---|
logLikelihood |
Log-likelihood. |
aic |
AIC. |
variance |
Variance. |
PrincipalComponentInfo
| JSON representation |
|---|
{ "principalComponentId": string, "explainedVariance": number, "explainedVarianceRatio": number, "cumulativeExplainedVarianceRatio": number } |
| Fields | |
|---|---|
principalComponentId |
Id of the principal component. |
explainedVariance |
Explained variance by this principal component, which is simply the eigenvalue. |
explainedVarianceRatio |
Explained_variance over the total explained variance. |
cumulativeExplainedVarianceRatio |
The explained_variance is pre-ordered in the descending order to compute the cumulative explained variance ratio. |
HparamTuningTrial
| JSON representation |
|---|
{ "trialId": string, "startTimeMs": string, "endTimeMs": string, "hparams": { object ( |
| Fields | |
|---|---|
trialId |
1-based index of the trial. |
startTimeMs |
Starting time of the trial. |
endTimeMs |
Ending time of the trial. |
hparams |
The hyperprameters selected for this trial. |
evaluationMetrics |
Evaluation metrics of this trial calculated on the test data. Empty in Job API. |
status |
The status of the trial. |
errorMessage |
Error message for FAILED and INFEASIBLE trial. |
trainingLoss |
Loss computed on the training data at the end of trial. |
evalLoss |
Loss computed on the eval data at the end of trial. |
hparamTuningEvaluationMetrics |
Hyperparameter tuning evaluation metrics of this trial calculated on the eval data. Unlike evaluation_metrics, only the fields corresponding to the hparam_tuning_objectives are set. |
TrainingOptions
| JSON representation |
|---|
{ "maxIterations": string, "lossType": enum ( |
| Fields | |
|---|---|
maxIterations |
The maximum number of iterations in training. Used only for iterative training algorithms. |
lossType |
Type of loss function used during training run. |
learnRate |
Learning rate in training. Used only for iterative training algorithms. |
l1Regularization |
L1 regularization coefficient. |
l2Regularization |
L2 regularization coefficient. |
minRelativeProgress |
When early_stop is true, stops training when accuracy improvement is less than 'min_relative_progress'. Used only for iterative training algorithms. |
warmStart |
Whether to train a model from the last checkpoint. |
earlyStop |
Whether to stop early when the loss doesn't improve significantly any more (compared to min_relative_progress). Used only for iterative training algorithms. |
inputLabelColumns[] |
Name of input label columns in training data. |
dataSplitMethod |
The data split type for training and evaluation, e.g. RANDOM. |
dataSplitEvalFraction |
The fraction of evaluation data over the whole input data. The rest of data will be used as training data. The format should be double. Accurate to two decimal places. Default value is 0.2. |
dataSplitColumn |
The column to split data with. This column won't be used as a feature. 1. When data_split_method is CUSTOM, the corresponding column should be boolean. The rows with true value tag are eval data, and the false are training data. 2. When data_split_method is SEQ, the first DATA_SPLIT_EVAL_FRACTION rows (from smallest to largest) in the corresponding column are used as training data, and the rest are eval data. It respects the order in Orderable data types: https://cloud.google.com/bigquery/docs/reference/standard-sql/data-types#data_type_properties |
learnRateStrategy |
The strategy to determine learn rate for the current iteration. |
initialLearnRate |
Specifies the initial learning rate for the line search learn rate strategy. |
labelClassWeights |
Weights associated with each label class, for rebalancing the training data. Only applicable for classification models. An object containing a list of |
userColumn |
User column specified for matrix factorization models. |
itemColumn |
Item column specified for matrix factorization models. |
distanceType |
Distance type for clustering models. |
numClusters |
Number of clusters for clustering models. |
modelUri |
Google Cloud Storage URI from which the model was imported. Only applicable for imported models. |
optimizationStrategy |
Optimization strategy for training linear regression models. |
hiddenUnits[] |
Hidden units for dnn models. |
batchSize |
Batch size for dnn models. |
dropout |
Dropout probability for dnn models. |
maxTreeDepth |
Maximum depth of a tree for boosted tree models. |
subsample |
Subsample fraction of the training data to grow tree to prevent overfitting for boosted tree models. |
minSplitLoss |
Minimum split loss for boosted tree models. |
boosterType |
Booster type for boosted tree models. |
numParallelTree |
Number of parallel trees constructed during each iteration for boosted tree models. |
dartNormalizeType |
Type of normalization algorithm for boosted tree models using dart booster. |
treeMethod |
Tree construction algorithm for boosted tree models. |
minTreeChildWeight |
Minimum sum of instance weight needed in a child for boosted tree models. |
colsampleBytree |
Subsample ratio of columns when constructing each tree for boosted tree models. |
colsampleBylevel |
Subsample ratio of columns for each level for boosted tree models. |
colsampleBynode |
Subsample ratio of columns for each node(split) for boosted tree models. |
numFactors |
Num factors specified for matrix factorization models. |
feedbackType |
Feedback type that specifies which algorithm to run for matrix factorization. |
walsAlpha |
Hyperparameter for matrix factoration when implicit feedback type is specified. |
kmeansInitializationMethod |
The method used to initialize the centroids for kmeans algorithm. |
kmeansInitializationColumn |
The column used to provide the initial centroids for kmeans algorithm when kmeans_initialization_method is CUSTOM. |
timeSeriesTimestampColumn |
Column to be designated as time series timestamp for ARIMA model. |
timeSeriesDataColumn |
Column to be designated as time series data for ARIMA model. |
autoArima |
Whether to enable auto ARIMA or not. |
nonSeasonalOrder |
A specification of the non-seasonal part of the ARIMA model: the three components (p, d, q) are the AR order, the degree of differencing, and the MA order. |
dataFrequency |
The data frequency of a time series. |
calculatePValues |
Whether or not p-value test should be computed for this model. Only available for linear and logistic regression models. |
includeDrift |
Include drift when fitting an ARIMA model. |
holidayRegion |
The geographical region based on which the holidays are considered in time series modeling. If a valid value is specified, then holiday effects modeling is enabled. |
holidayRegions[] |
A list of geographical regions that are used for time series modeling. |
timeSeriesIdColumn |
The time series id column that was used during ARIMA model training. |
timeSeriesIdColumns[] |
The time series id columns that were used during ARIMA model training. |
forecastLimitLowerBound |
The forecast limit lower bound that was used during ARIMA model training with limits. To see more details of the algorithm: https://otexts.com/fpp2/limits.html |
forecastLimitUpperBound |
The forecast limit upper bound that was used during ARIMA model training with limits. |
horizon |
The number of periods ahead that need to be forecasted. |
autoArimaMaxOrder |
The max value of the sum of non-seasonal p and q. |
autoArimaMinOrder |
The min value of the sum of non-seasonal p and q. |
numTrials |
Number of trials to run this hyperparameter tuning job. |
maxParallelTrials |
Maximum number of trials to run in parallel. |
hparamTuningObjectives[] |
The target evaluation metrics to optimize the hyperparameters for. |
decomposeTimeSeries |
If true, perform decompose time series and save the results. |
cleanSpikesAndDips |
If true, clean spikes and dips in the input time series. |
adjustStepChanges |
If true, detect step changes and make data adjustment in the input time series. |
enableGlobalExplain |
If true, enable global explanation during training. |
sampledShapleyNumPaths |
Number of paths for the sampled Shapley explain method. |
[...]
